## ros-rolling-ur-client-library 1.3.3

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../CMakeModules/" ${CMAKE_MODULE_PATH})

project(ur_client_library_tests)

# This will allow cmake 3.0 and above to fail on missing link targets (when specified with an double colon syntax)
# Note that not all packages are support the colon syntax, but if they do it is recomended to use this syntax, since it is less error prone.
if(POLICY CMP0028)
  cmake_policy(SET CMP0028 NEW)
endif()

if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

# Find dependencies for testing
include(FindGTestPackage)
find_gtest_package(GTEST_LIBRARIES)
if (NOT TARGET ur_client_library::urcl)
  find_package(ur_client_library REQUIRED)
endif()

# Check C++11 support
include(DefineCXX17CompilerFlag)
DEFINE_CXX_17_COMPILER_FLAG(CXX17_FLAG)


# Build Tests
if (INTEGRATION_TESTS)
  # Integration tests require a robot reachable at 192.168.56.101. Therefore, they have to be
  # activated separately.
  add_executable(rtde_tests test_rtde_client.cpp)
  target_compile_options(rtde_tests PRIVATE ${CXX17_FLAG})
  target_include_directories(rtde_tests PRIVATE ${GTEST_INCLUDE_DIRS})
  target_link_libraries(rtde_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
  gtest_add_tests(TARGET      rtde_tests
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )

  add_executable(dashboard_client_tests test_dashboard_client.cpp)
  target_compile_options(dashboard_client_tests PRIVATE ${CXX17_FLAG})
  target_include_directories(dashboard_client_tests PRIVATE ${GTEST_INCLUDE_DIRS})
  target_link_libraries(dashboard_client_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
  gtest_add_tests(TARGET      dashboard_client_tests
  )

  add_executable(spline_tests test_spline_interpolation.cpp)
  target_compile_options(spline_tests PRIVATE ${CXX17_FLAG})
  target_include_directories(spline_tests PRIVATE ${GTEST_INCLUDE_DIRS})
  target_link_libraries(spline_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
  gtest_add_tests(TARGET      spline_tests
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
else()
  message(STATUS "Skipping integration tests.")
endif()


add_executable(primary_parser_tests test_primary_parser.cpp)
target_compile_options(primary_parser_tests PRIVATE ${CXX17_FLAG})
target_include_directories(primary_parser_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(primary_parser_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET      primary_parser_tests
)

add_executable(rtde_data_package_tests test_rtde_data_package.cpp)
target_compile_options(rtde_data_package_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_data_package_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_data_package_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET      rtde_data_package_tests
)

add_executable(rtde_parser_tests test_rtde_parser.cpp)
target_compile_options(rtde_parser_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_parser_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_parser_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET      rtde_parser_tests
)

add_executable(tcp_server_tests test_tcp_server.cpp)
target_compile_options(tcp_server_tests PRIVATE ${CXX17_FLAG})
target_include_directories(tcp_server_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(tcp_server_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET      tcp_server_tests
)

add_executable(script_sender_tests test_script_sender.cpp)
target_compile_options(script_sender_tests PRIVATE ${CXX17_FLAG})
target_include_directories(script_sender_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(script_sender_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET      script_sender_tests
)

add_executable(reverse_interface_tests test_reverse_interface.cpp)
target_compile_options(reverse_interface_tests PRIVATE ${CXX17_FLAG})
target_include_directories(reverse_interface_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(reverse_interface_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET reverse_interface_tests
)

add_executable(trajectory_point_interface_tests test_trajectory_point_interface.cpp)
target_compile_options(trajectory_point_interface_tests PRIVATE ${CXX17_FLAG})
target_include_directories(trajectory_point_interface_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(trajectory_point_interface_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET trajectory_point_interface_tests
)

add_executable(rtde_control_package_pause_tests test_rtde_control_package_pause.cpp)
target_compile_options(rtde_control_package_pause_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_control_package_pause_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_control_package_pause_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET rtde_control_package_pause_tests
)

add_executable(rtde_control_package_start_tests test_rtde_control_package_start.cpp)
target_compile_options(rtde_control_package_start_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_control_package_start_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_control_package_start_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET rtde_control_package_start_tests
)

add_executable(rtde_control_package_setup_outputs_tests test_rtde_control_package_setup_outputs.cpp)
target_compile_options(rtde_control_package_setup_outputs_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_control_package_setup_outputs_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_control_package_setup_outputs_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET rtde_control_package_setup_outputs_tests
)

add_executable(rtde_control_package_setup_inputs_tests test_rtde_control_package_setup_inputs.cpp)
target_compile_options(rtde_control_package_setup_inputs_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_control_package_setup_inputs_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_control_package_setup_inputs_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET rtde_control_package_setup_inputs_tests
)

add_executable(rtde_get_urcontrol_version_tests test_rtde_get_urcontrol_version.cpp)
target_compile_options(rtde_get_urcontrol_version_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_get_urcontrol_version_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_get_urcontrol_version_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET rtde_get_urcontrol_version_tests
)

add_executable(rtde_request_protocol_version_tests test_rtde_request_protocol_version.cpp)
target_compile_options(rtde_request_protocol_version_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_request_protocol_version_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_request_protocol_version_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET rtde_request_protocol_version_tests
)

add_executable(rtde_writer_tests test_rtde_writer.cpp)
target_compile_options(rtde_writer_tests PRIVATE ${CXX17_FLAG})
target_include_directories(rtde_writer_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(rtde_writer_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET rtde_writer_tests
)

add_executable(version_information_tests test_version_information.cpp)
target_compile_options(version_information_tests PRIVATE ${CXX17_FLAG})
target_include_directories(version_information_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(version_information_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET version_information_tests
)

add_executable(bin_parser_tests test_bin_parser.cpp)
target_compile_options(bin_parser_tests PRIVATE ${CXX17_FLAG})
target_include_directories(bin_parser_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(bin_parser_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET bin_parser_tests
)

add_executable(package_serializer_tests test_package_serializer.cpp)
target_compile_options(package_serializer_tests PRIVATE ${CXX17_FLAG})
target_include_directories(package_serializer_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(package_serializer_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET package_serializer_tests
)

add_executable(tcp_socket_tests test_tcp_socket.cpp)
target_compile_options(tcp_socket_tests PRIVATE ${CXX17_FLAG})
target_include_directories(tcp_socket_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(tcp_socket_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET tcp_socket_tests
)

add_executable(stream_tests test_stream.cpp)
target_compile_options(stream_tests PRIVATE ${CXX17_FLAG})
target_include_directories(stream_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(stream_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET stream_tests
)

add_executable(producer_tests test_producer.cpp)
target_compile_options(producer_tests PRIVATE ${CXX17_FLAG})
target_include_directories(producer_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(producer_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET producer_tests
)

add_executable(pipeline_tests test_pipeline.cpp)
target_compile_options(pipeline_tests PRIVATE ${CXX17_FLAG})
target_include_directories(pipeline_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(pipeline_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET pipeline_tests
)

add_executable(script_command_interface_tests test_script_command_interface.cpp)
target_compile_options(script_command_interface_tests PRIVATE ${CXX17_FLAG})
target_include_directories(script_command_interface_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(script_command_interface_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET script_command_interface_tests
)

add_executable(ur_driver_tests test_ur_driver.cpp)
target_compile_options(ur_driver_tests PRIVATE ${CXX17_FLAG})
target_include_directories(ur_driver_tests PRIVATE ${GTEST_INCLUDE_DIRS})
target_link_libraries(ur_driver_tests PRIVATE ur_client_library::urcl ${GTEST_LIBRARIES})
gtest_add_tests(TARGET      ur_driver_tests
)

=== debian/changelog ===
ros-rolling-ur-client-library (1.3.3-1jammy) jammy; urgency=high

  * Add support for setting socket max num tries and reconnect timeout (#172 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/172>)
  * Unify socket open (#174 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/174>)
  * Added handling of spline interpolation with end point velocities (#169 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/169>)
  * Throws exception if the URScript file doesn't exists (#173 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/173>)
  * Added check to ensure receive timeout isn't overwritten (#171 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/171>)
  * Added RTDEClient constructor with vector recipes (#143 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/143>)
  * Only warn if system is not setup for FIFO scheduling (#170 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/170>)
  * Ensuring that the Timestamp is always in the output recipe (#168 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/168>)
  * CI: Add Iron to CI tests (#167 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/167>)
  * Add issue templates for bugs and features (#166 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/166>)
  * Updated license (#164 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/164>)
  * Bugfixes for spline interpolation (#162)
    
    Add separate rounding in the conversion from float to int32
    
    Add more debug printout for splines
    
    Add Copying flight reports if CI fails
    
    Update ursim mininum version in start_ursim.sh
  * Fix the prerelease ci for Melodic (#163 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/163>)
  * Contributors: Dag-Are Trydal, Felix Exner, Felix Exner (fexner), Mads Holm Peters, Michael Eriksen, RobertWilbrandt, Rune Søe-Knudsen, urmahp, urrsk

 -- Felix Exner <exner@fzi.de>  Tue, 05 Sep 2023 00:00:00 -0000

ros-rolling-ur-client-library (1.3.2-1jammy) jammy; urgency=high

  * Add a cmake option to activate address sanitizers (#146 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/146>)
  * Install start ursim (#155 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/155>)
  * Add spline interpolation on robot (#151 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/151>)
  * Add codecov.yml to exclude test and examples folders (#152 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/152>)
  * Make URSim log files available as artifacts also for the CI-industrial (#153 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/153>)
  * Remove Foxy from CI
  * Add a script to run the examples instead of run-parts
  * Add SaveLog command to the Dashboard client
  * Make URSim log files available as artifacts
  * Specifically set RTDE pipeline producer to FIFO scheduling (#139 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/139>)
  * Added support for force_mode, freedrive and tool contact (#138 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/138>)
  * Docs: Update link to ros_industrial_cmake_boilerplate
  * Added tests for the comm classes (#129 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/129>)
  * Changed num_retries from static to an unsigned int (#136 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/136>)
  * Build downstream humble version from humble branch (#132 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/132>)
  * Contributors: Felix Exner, Mads Holm Peters, Rune Søe-Knudsen, Robert Wilbrandt

 -- Felix Exner <exner@fzi.de>  Thu, 13 Jul 2023 00:00:00 -0000

ros-rolling-ur-client-library (1.3.1-1jammy) jammy; urgency=high

  * CI: Add a prerelease check that calls bloom-generate (#134 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/134>)
  * Contributors: Felix Exner

 -- Felix Exner <exner@fzi.de>  Wed, 30 Nov 2022 00:00:00 -0000

ros-rolling-ur-client-library (1.3.0-1jammy) jammy; urgency=high

  * Dashboard commands, Docker Image and CI step for running the examples #127 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/127>
  * Added tests for the rtde interface clasess (#125 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/125>)
  * Fix unique_ptr type (#124 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/124>)
  * Fix 'BEGIN_REPLACE' - used in tool_communication (copy #101 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/101>) (#120 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/120>)
    (cherry picked from commit f7ce9f73181848f3957c660647fac0e5325862b9)
    Co-authored-by: rxjia <mailto:60809735+rxjia@users.noreply.github.com>
  * Contributors: Felix Exner, Mads Holm Peters, RobertWilbrandt, Rune Søe-Knudsen, mergify[bot], urmarp, urrsk

 -- Felix Exner <exner@fzi.de>  Mon, 28 Nov 2022 00:00:00 -0000

ros-rolling-ur-client-library (1.2.0-1jammy) jammy; urgency=high

  * Initialized receive timeout and changed exception to warning (#118 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/118>)
  * Added tests for the control interface classes (#112 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/112>)
  * Added note about Polyscope version requirement
  * Added tcp_offset
  * Added interface for forwarding script commands to the robot, that is … (#111 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/111>)


=== debian/control ===
Source: ros-rolling-ur-client-library
Section: misc
Priority: optional
Maintainer: Felix Exner <exner@fzi.de>
Build-Depends: debhelper (>= 9.0.0), cmake, ros-rolling-ros-workspace
Homepage: http://wiki.ros.org/ur_client_library
Standards-Version: 3.9.2

Package: ros-rolling-ur-client-library
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-ament-cmake, ros-rolling-ros-workspace
Description: Standalone C++ library for accessing Universal Robots interfaces.
 This has been forked off the ur_robot_driver.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-ur-client-library//opt/ros/rolling/lib/:$(CURDIR)/debian/ros-rolling-ur-client-library//opt/ros/rolling/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install
